<template>
    <div class="match-list">
        <ul>
            <li v-for="match in sortedMatches" :key="match.id" @click="selectMatch(match)" :class="{'selected': match.id === (selectedMatch ? selectedMatch.id : null)}">
                <div class="avatar">
                    <img :src="match.photo" />
                </div>
                <div class="match">
                    <div class="name">{{ match.name }}</div>
                    <div class="email">{{ match.email }}</div>
                </div>
                <span class="unread" v-if="match.unread_messages_count > 0">{{ match.unread_messages_count }}</span>
            </li>
        </ul>
    </div>
</template>

<script>
export default {
    props: {
        matches: {
            type: Object,
            required: true,
        },
    },
    data() {
        return {
            selectedMatch: this.matches.data[0]? this.matches.data[0] : null,
        };
    },
    methods: {
        selectMatch(match) {
            this.selectedMatch = match;
            this.$emit('selected', match);
        },
    },
    computed: {
        sortedMatches() {
            return _.sortBy(this.matches.data, (match) => {
                if (match == this.selectedMatch) {
                    return Infinity;
                }
            });
        },
    },

}
</script>

<style lang="scss" scoped>
.match-list {
    flex: 2;
    max-height: 100%;
    overflow-y: scroll;
    border-right: 1px solid #e6e6e6;
    ul {
        list-style: none;
        padding: 0;
        margin: 0;
        li {
            display: flex;
            align-items: center;
            height: 100px;
            padding: 0.5rem;
            border-bottom: 1px solid #e6e6e6;
            background-color: #fff;
            border-left: 5px solid transparent;
            cursor: pointer;
            &.selected {
                background-color: #f5f5f5;
                border-left-color: #2196f3;

            }
            .avatar {
                width: 2rem;
                height: 2rem;
                margin-right: 0.5rem;
                img {
                    width: 100%;
                    height: 100%;
                    border-radius: 50%;
                }
            }
            .match {
                flex: 1;
                .name {
                    font-size: 0.9rem;
                    font-weight: bold;
                }
                .email {
                    font-size: 0.8rem;
                }
            }
            .unread {
                background-color: #ff0000;
                color: #fff;
                font-size: 0.8rem;
                padding: 0.2rem 0.5rem;
                border-radius: 50%;
                margin-left: 0.5rem;
            }
        }
    }
}
</style>
